config/routes.rb
Rails.application.routes.draw do

  match 'registration/start', via: [:get, :post, :put]
  match 'registration/register', via: [:get, :post]
  match 'registration/wei_register', via: [:get, :post]
  get 'registration/questions'
  post 'registration/pay'
  match 'registration/card', via: [:get, :post]
  get 'registration/details'

  ActiveAdmin.routes(self)

  resources :students do
    member do
      patch :card
    end
    resources :memberships, only: [:index]
    resources :payments, only: [:create, :update, :index]
  end

  resources :payments, only: [:index, :logs]
  get 'payments/logs', controller: 'payments', action: 'logs', as: :logs
  get 'payments/stats', controller: 'payments', action: 'stats', as: :trezo_stats

  scope 'wei' do
    resources :wei_registrations do
      member do
        post 'pay', as: :pay
      end
      collection do
        get 'waiting'
        get 'deposit'
        get 'registered'
        get 'unregistered'
        get 'to_refund'
        get 'parental'
      end
    end
    resources :wei_bungalows
    resources :wei_buses
  end

  get 'email/:key' => 'email#show', as: :view_email
  get 'email' => 'email#show' unless Rails.env.production?

  devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }

  namespace :api, default: {format: :json}, path: '/api' do
    scope module: :version1 do
      match '*path', :controller => 'api', :action => 'cors', via: [:options]
      get 'auth' => 'api#auth'
      get 'membership' => 'membership#show'
      get 'students' => 'membership#index'
      get 'mass_students' => 'membership#bulk'
    end
  end

  root 'students#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/views/layouts/_headers.html.haml
= csrf_meta_tags
%link{rel:"icon", type:"image/png", href: image_url('logo-bde.png')}
= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload'
= javascript_include_tag 'application', 'data-turbolinks-track': 'reload'
%meta(name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no")

app/views/layouts/_navbar.html.haml
.pos-f-t
  %nav.navbar.navbar-light.navbar-static-top.bg-faded
    .container
      %button.navbar-toggler.hidden-sm-up{data: {target: '#exCollapsingNavbar2', toggle:'collapse'}, type: "button"}
        \☰
      #exCollapsingNavbar2.collapse.navbar-toggleable-xs
        %a.navbar-brand{:href => "#"}
          = image_tag 'logo-bde.png', class: 'img-fluid', style: 'max-height:33px'
        - if current_user
          %ul.nav.navbar-nav
            - if can? :read, Student
              %li.nav-item
                = link_to t('registration.registration'), registration_start_url, class: 'nav-link'
              - unless current_user.has_role? 'cdp'
                %li.nav-item
                  = link_to t('students.index.students'), students_path, class: 'nav-link'
            - if can? :read, WeiRegistration and not current_user.has_role? 'cdp'
              %li.nav-item.dropdown
                %a.nav-link.dropdown-toggle{data: {toggle:'dropdown'}, role: 'button'}=t('.wei.wei')
                .dropdown-menu
                  - if can? :read, WeiRegistration
                    = link_to t('.registrations'), wei_registrations_path, class: 'dropdown-item'
                  .dropdown-divider
                  = link_to t('.wei.registered'), registered_wei_registrations_path, class: 'dropdown-item'
                  = link_to t('.wei.waiting'), waiting_wei_registrations_path, class: 'dropdown-item'
                  = link_to t('.wei.deposit'), deposit_wei_registrations_path, class: 'dropdown-item'
                  -#= link_to t('.wei.to_refund'), to_refund_wei_registrations_path, class: 'dropdown-item'
                  -#= link_to t('.wei.unregistered'), unregistered_wei_registrations_path, class: 'dropdown-item'
                  .dropdown-divider
                  - if can? :read, WeiBungalow
                    = link_to t('.bungalows'), wei_bungalows_path, class: 'dropdown-item'
                  - if can? :read, WeiBus
                    = link_to t('.buses'), wei_buses_path, class: 'dropdown-item'
            - if current_user.has_role? :trezo
              %li.nav-item.dropdown
                %a.nav-link.dropdown-toggle{data: {toggle:'dropdown'}, role: 'button'}=t('.trezo.trezo')
                .dropdown-menu
                  = link_to t('.trezo.logs'), logs_path, class: 'dropdown-item'
                  = link_to t('.trezo.accounts'), trezo_stats_path, class: 'dropdown-item'

            - if can? :admin, :all
              %li.nav-item
                = link_to t('.admin'), admin_root_url, class: 'nav-link'
          #user.dropdown.pull-xs-right
            .btn.btn-outline-primary.dropdown-toggle{data: {toggle:'dropdown'}}
              .fa.fa-user
            .dropdown-menu.dropdown-menu-right
              = link_to destroy_user_session_path, method: :delete, class:'dropdown-item text-danger' do
                .fa.fa-sign-out
                = t('.logout')
        - else
          = link_to new_user_session_path, class:'pull-xs-right btn btn-outline-primary' do
            .fa.fa-sign-in
            = t('.login')

app/views/layouts/application.html.haml
!!!
%html
  %head
    - if content_for? :title
      %title
        = yield(:title)
        =' - Adhésion'
    - else
      %title Adhésion
    = render 'layouts/headers'
  %body
    = render 'layouts/navbar'
    #main.container
      = flash_messages
      = yield
    :javascript
      var MARSU = {
        departments: #{Department.all.to_json},
        study_years: #{StudyYear.all.to_json},
        memberships: #{Membership.all.to_json}
      };